<template>
    <form class="mb-5" @submit.prevent="addPerson">
        <label class="d-block mb-3">
            <span class="form-label">Vorname</span>
            <input type="text" v-model="newPersonsFirstName" class="form-control" required>
        </label>
        <label class="d-block mb-3">
            <span class="form-label">Nachname</span>
            <input type="text" v-model="newPersonsLastName" class="form-control" required>
        </label>
        <button type="submit" class="btn btn-primary">Hinzufügen</button>
    </form>

    <PersonsTable
            @update-person="updateSinglePerson"
            :persons-array="persons"
    >
        <template #no-content> </template>
        <template #default>
            <h1>Hallo Welt</h1>
            <h2>Test</h2>
        </template>
        <template #footer>
            <h3>Footer</h3>
        </template>
    </PersonsTable>
    <hr>
    <PersonsTable @update-person="updateSinglePerson" :persons-array="persons">
        <template #default>
            <h1>Hallo Welt</h1>
            <h2>Test</h2>
        </template>
        <template #footer>
            <h3>Footer</h3>
        </template>
    </PersonsTable>
    <hr>
    <PersonsTable :no-persons-text="missingPersonsText" @update-person="updateSinglePerson" :persons-array="persons">
        <template #default>
            <h1>Hallo Welt</h1>
            <h2>Test</h2>
        </template>
        <template #footer>
            <h3>Footer</h3>
        </template>
    </PersonsTable>
</template>

<script setup>
    import {ref} from "vue";
    import PersonsTable from "@/components/PersonsTable.vue";

    const missingPersonsText = ref('Dings')
    const persons = ref([
        /*{
            firstName: 'Max',
            lastName: 'Muster'
        },
        {
            firstName: 'Harry',
            lastName: 'Potter'
        }*/
    ])

    const newPersonsFirstName = ref('')
    const newPersonsLastName = ref('')

    function addPerson() {
        console.log(newPersonsFirstName.value, newPersonsLastName.value)
        persons.value.push({
            firstName: newPersonsFirstName.value,
            lastName: newPersonsLastName.value
        })
        newPersonsFirstName.value = ''
        newPersonsLastName.value = ''
    }

    function updateSinglePerson(personIndex, personData) {
        console.log('update person in PersonsArray.vue', personIndex, personData)
        persons.value.splice(personIndex, 1, personData)
    }
</script>